#ifndef __MEMM_PARAMETERS_H__
#define __MEMM_PARAMETERS_H__

#include <iostream>
#include <fstream>
#include <cstring>

#define DEFAULT_PARAMETERS_FILE "Parameters.xml"

using namespace std;

enum MEMM_parameters_t {
  MEMM_PARENTS_FILE_NAME,
  MEMM_PARENTS_FILE_NUMBER_OF_LOCUS,
  MEMM_PARENTS_FILE_CLASS_COV,
  MEMM_PARENTS_FILE_QT_COV,
  MEMM_PARENTS_FILE_WEIGHT_VAR,
  MEMM_OFFSPRING_FILE_NAME,
  MEMM_OFFSPRING_FILE_NUMBERS_OF_LOCUS,
  MEMM_AF_FILE_MODE,
  MEMM_AF_FILE_NAME,
  MEMM_DIST_FILE_MODE,
  MEMM_DIST_FILE_NAME,
  MEMM_LOCUS_ERROR,
  MEMM_LOCUS_ERROR_FILE,
  MEMM_LOCUS_ERROR_NMISTYPEMAX,
  MEMM_IND_FEC_DIST,
  MEMM_SEED,
  MEMM_GAMAS_INIT,
  MEMM_GAMAS_MIN,
  MEMM_GAMAS_MAX,
  MEMM_SCALES_INIT,
  MEMM_SCALES_MIN,
  MEMM_SCALES_MAX,
  MEMM_SCALESLDD_INIT,		
  MEMM_SCALESLDD_MIN,
  MEMM_SCALESLDD_MAX,
  MEMM_SHAPESLDD_INIT,
  MEMM_SHAPESLDD_MIN,
  MEMM_SHAPESLDD_MAX,
  MEMM_ALPHALDD_INIT,
  MEMM_ALPHALDD_MIN,
  MEMM_ALPHALDD_MAX,
  MEMM_BETALDD_INIT,
  MEMM_BETALDD_MIN,
  MEMM_BETALDD_MAX,	
  MEMM_SHAPE_S_INIT,
  MEMM_SHAPE_S_MIN,
  MEMM_SHAPE_S_MAX,
    // NEW Anisotropie
    MEMM_KAPPAS_INIT,
    MEMM_KAPPAS_MIN,
    MEMM_KAPPAS_MAX,
    MEMM_THETAS_INIT,
    MEMM_THETAS_MIN,
    MEMM_THETAS_MAX,

  MEMM_MIG_RATE_S_INIT,
  MEMM_MIG_RATE_S_MIN,
  MEMM_MIG_RATE_S_MAX,
  MEMM_GAMA_INIT,
  MEMM_GAMA_MIN,
  MEMM_GAMA_MAX,

// Début modif
  MEMM_PI0_INIT,
  MEMM_PI0_MIN,
  MEMM_PI0_MAX,
  MEMM_PI0S_INIT,
  MEMM_PI0S_MIN,
  MEMM_PI0S_MAX,
// Fin modif

  MEMM_DELTA_INIT,
  MEMM_DELTA_MIN,
  MEMM_DELTA_MAX,
  MEMM_SHAPE_B_INIT,
  MEMM_SHAPE_B_MIN,
  MEMM_SHAPE_B_MAX,

    // NEW ANISOTROPIE    
    MEMM_KAPPA_INIT,
    MEMM_KAPPA_MIN,
    MEMM_KAPPA_MAX,
    MEMM_THETA_INIT,
    MEMM_THETA_MIN,
    MEMM_THETA_MAX,

  MEMM_MIG_RATE_M_INIT,
  MEMM_MIG_RATE_M_MIN,
  MEMM_MIG_RATE_M_MAX,
  MEMM_SELF_RATE_S_INIT,
  MEMM_SELF_RATE_S_MIN,
  MEMM_SELF_RATE_S_MAX,
  MEMM_BURNIN,
  MEMM_ITE,
  MEMM_THIN,
  MEMM_GAMA_FILE_NAME,
  MEMM_IND_FEC_FILE_NAME,
  MEMM_DISP_FILE_NAME,
    MEMM_POSTERIOR_FILE_NAME, // NEW EK -> Computing posterior probabilities of parents
    MEMM_POSTERIOR_TYPE         // NEW EK -> Computing posterior probabilities of parents
};

class Parameters {

  public : 
    Parameters();
    Parameters(const char * filein);
    virtual ~Parameters();
    bool isOK();
    virtual char * getValue(MEMM_parameters_t valueName)=0;
    virtual bool setValue(MEMM_parameters_t valueName, char * value)=0;
    //virtual bool setValue(MEMM_parameters_t valueName, unsigned int * value)=0;
  protected :
    bool isOK_;
    char * parametersFileName_;

};

#endif
