#ifndef GENOTYPE_H
#define GENOTYPE_H

#include "locus.h"
#include <fstream>
#include <vector>

class genotype
{
    public:
        genotype(int nloc, std::ifstream & file_in);
        genotype(int nloc);
        genotype() {};
        virtual ~genotype();

        std::vector<locus> getLocus() const {return this->_genonuc;}
        locus getLocus(int k) const {return this->_genonuc[k];}

        double mendel(const genotype & mere, const genotype & pere, int nl, const std::vector<int> & na, const std::vector<std::map<int,int> > & sizeall, const std::vector<std::vector<double> > & freqall) const;
        double mendelError(const genotype & mere, const genotype & pere, int nl, const std::vector<int> & na, const std::vector<std::map<int,int> > & sizeall, const std::vector<std::vector<double> > & freqall, const std::vector < std::vector < std::vector <double> > > & materror, int & nmistype) const;

        void afficher() const;
    protected:
    private:
        std::vector<locus> _genonuc;
};

#endif // GENOTYPE_H
