#ifndef INDIVIDU_H
#define INDIVIDU_H

#include <string>
#include <iostream>
#include "genotype.h"

class individu
{
    protected:
        std::string _nom;
        genotype _geno;

    public:
        individu(const std::string & name, const genotype & geno);
        individu(const std::string & name);
        individu() {};
        virtual ~individu() {}

        const std::string & getName() const {return this->_nom;}
        genotype getGeno() const {return this->_geno;}
        locus getGeno(int k) const {return (this->_geno).getLocus(k);}

        virtual void afficher() const;

        // temporaly added here ### HAVE TO ### check individu class and daugthers class
        virtual std::string getMere() const {std::cerr<<"Individu::getMere() should not use this function"<<std::endl; return "";}
        virtual double mendel (const individu & mere , const individu & pere, int nl, std::vector<int> na,  std::vector < std::map<int,int> > sizeall, const std::vector < std::vector<double> > & freqall) const{};
        virtual double mendel (const individu & mere , const individu & pere, int nl, std::vector<int> na,  std::vector < std::map<int,int> > sizeall, const std::vector < std::vector<double> > & freqall, const std::vector < std::vector < std::vector <double> > > & materror, int & nmistype) const{};
//        virtual double dist(const individu & ind) const{};


};

#endif // INDIVIDU_H
