#include "MEMM_seedlings.hpp"

MEMM_seedlings::MEMM_seedlings()
{
  cout<< "MEMM : Seedlings mode"<<endl;
  Nposterior = 0;
}

MEMM_seedlings::~MEMM_seedlings()
{
  
  Vec_Fecs.clear();
  Vec_Fecp.clear();
  if(pLois) delete pLois;
  
}

void MEMM_seedlings::mcmc(int nbIteration, int thinStep)
{

    ofstream cSuivi ("suiviPasAPas.txt");
    int suivi=0;

  double lastFecLogLiks, nextFecLogLiks;
  double lastFecLogLikp, nextFecLogLikp;
  double previousValue, nextValue;
  double previousValue2;
  long double previousLogLik, nextLogLik;

  int xpourCent = nbIteration/20;
  if(!xpourCent) xpourCent=1;

    
  lastFecLogLikp = pLoi->logLik(NPar, Vec_Fecp,GamA);
  lastFecLogLiks = pLois->logLik(NPar, Vec_Fecs,GamAs);
    
    logLik(posterior);

    //cerr <<lastFecLogLikp;
    //cerr << PosteriorMeres[1][1] << " " << PosteriorMeres[5][NPar] << endl;

    //previousLogLik = logLik();

  //output start value
  if(thinStep){

      previousLogLik = logLik(posterior);  // EK -> Computing posterior probabilities of parents
      cout <<previousLogLik << " ";

    *ParamFec << "0 " << lastFecLogLiks << " " << GamAs << " " << lastFecLogLikp << " " << GamA << endl;
    ParamFec->flush();
    *IndivFec << "0 " ;
    for (int p=0; p<NPar; p++) {*IndivFec << Vec_Fecs[p] << " ";}
    for (int p=0; p<NPar; p++) {*IndivFec << Vec_Fecp[p] << " ";}
    *IndivFec << endl;
    IndivFec->flush();
    *ParamDisp << "0 " << previousLogLik
      << " " << Scales
      << " " << Shapes
      << " " << Kappas
      << " " << Thetas
      << " " << Migs
      << " " << Scale
      << " " << Shape
      << " " << Kappa
      << " " << Theta
      << " " << Mig
      << " " << Self
      <<endl;
    ParamDisp->flush();

  }

  else {previousLogLik = logLik();       cout <<previousLogLik << " ";   }  // EK -> Computing posterior probabilities of parents

  if(nbIteration) cout << "it=1..."<< std::endl;
  for(int ite=1; ite<=nbIteration; ite++)
  {
    if (ite % xpourCent == 0) {cout << "it="<<ite << "..."<< std::endl;}

      if(thinStep && (ite%thinStep == 0)) {logLik(posterior);
          //cout << PosteriorMeres[1][1] << " " << PosteriorMeres[5][NPar] << endl;
      }

    //GamAs- fecundities distribution
    //nextValue = pow(GamAs, exp(0.2*gauss()));
      nextValue = GamAs*exp(0.2*gauss());
    if( nextValue>mGamAs && nextValue<MGamAs )
    {
      lastFecLogLiks = pLois->logLik(NPar, Vec_Fecs,GamAs);
      nextFecLogLiks = pLois->logLik(NPar, Vec_Fecs, nextValue);
        if (suivi>0) cSuivi << ite << " GamAs " << nextValue << " " << lastFecLogLiks << " " << nextFecLogLiks << " " << nextFecLogLiks-lastFecLogLiks << " ";
      if( accept() < exp(nextFecLogLiks-lastFecLogLiks) )
      {
        GamAs = nextValue;
        lastFecLogLiks = nextFecLogLiks;
        pLois->setDParam(MEMM_LOI_GAMA,GamAs);
          if (suivi>0) cSuivi << "Accept" << endl;
      }
        else if (suivi>0) cSuivi << "Reject" << endl;
    }
    if(thinStep)*ParamFec << ite << " " << lastFecLogLiks << " " << GamAs << " ";

    //GamA (GamAp)- fecundities distribution
      //nextValue = pow(GamA, exp(tune*gauss()));
      nextValue = GamA*exp(0.2*gauss());
    if( nextValue>mGamA && nextValue<MGamA )
    {
      lastFecLogLikp = pLoi->logLik(NPar, Vec_Fecp,GamA);
      nextFecLogLikp = pLoi->logLik(NPar, Vec_Fecp, nextValue);
        if (suivi>0) cSuivi << ite << " Gamap " << nextValue << " "  << lastFecLogLikp << " " << nextFecLogLikp << " " << nextFecLogLikp-lastFecLogLikp << " ";
      if( accept() < exp(nextFecLogLikp-lastFecLogLikp) )
      {
        GamA = nextValue;
        lastFecLogLikp = nextFecLogLikp;
        pLoi->setDParam(MEMM_LOI_GAMA,GamA);
          if (suivi>0) cSuivi << "Accept" << endl;
      }
        else if (suivi>0) cSuivi << "Reject" << endl;
    }
    if(thinStep)*ParamFec << lastFecLogLikp << " " << GamA << endl;

    for(int p=0 ; p<NPar ; p++)
    {
      previousValue = Vec_Fecs[p];
      previousValue2 = Vec_Fecp[p];
      pLois->tirage(Vec_Fecs[p]);
      pLoi->tirage(Vec_Fecp[p]);
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " Fecundities " << p << " "  << previousValue << " "  << Vec_Fecs[p] << " " << previousValue2 << " "  << Vec_Fecp[p] << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if(accept()<exp(nextLogLik-previousLogLik)) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
      else
      {
        Vec_Fecs[p] = previousValue;
        Vec_Fecp[p] = previousValue2;
          if (suivi>0) cSuivi << "Reject" << endl;
      }
    }

    if(thinStep && (ite%thinStep == 0))
    {
      *IndivFec << ite << " " ;
      for (int p=0; p<NPar; p++) {*IndivFec << Vec_Fecs[p] << " ";}
      for (int p=0; p<NPar; p++) {*IndivFec << Vec_Fecp[p] << " ";}
      *IndivFec << endl;
      IndivFec->flush();
    }

    // change Scales
    previousValue = Scales;
    Scales = previousValue*exp(0.2*gauss());
    if( Scales>mScales && Scales<MScales)
    {
      as=Scales*exp(gammln(2/Shapes)-gammln(3/Shapes));
      abs=-pow(as,-Shapes);
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " FemaleParam1 " << Scales << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
      else
      {
        Scales = previousValue;
        as=Scales*exp(gammln(2/Shapes)-gammln(3/Shapes));
        abs=-pow(as,-Shapes);
          if (suivi>0) cSuivi << "Reject" << endl;
      }
    }
    else Scales = previousValue;

    //change Shapes
    previousValue = Shapes;
    Shapes = previousValue*exp(0.2*gauss());
    if( Shapes>mShapes && Shapes<MShapes)
    {
      as=Scales*exp(gammln(2/Shapes)-gammln(3/Shapes));
      abs=-pow(as,-Shapes);
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " FemaleParam2 " << Shapes << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
      else{
        Shapes = previousValue;
        as=Scales*exp(gammln(2/Shapes)-gammln(3/Shapes));
        abs=-pow(as,-Shapes);
          if (suivi>0) cSuivi << "Reject" << endl;
      }
    }
    else Shapes = previousValue;

      
      //change Kappas
      previousValue = Kappas;
      Kappas = previousValue*exp(0.2*gauss());
      if( Kappas>mKappas && Kappas<MKappas)
      {
          nextLogLik = logLik();
          if (suivi>0) cSuivi << ite << " FemaleParam3 " << Kappas << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
          if( accept() < exp(nextLogLik-previousLogLik) ) {
              previousLogLik = nextLogLik;
              if (suivi>0) cSuivi << "Accept" << endl;
          }
          else{
              Kappas = previousValue;
              if (suivi>0) cSuivi << "Reject" << endl;
          }
      }
      else Kappas = previousValue;

      //change Thetas
      previousValue = Thetas;
      Thetas = fmod((previousValue + 0.2*gauss()),3.14159);
      if( Thetas>mThetas && Thetas<MThetas)
      {
          nextLogLik = logLik();
          if (suivi>0) cSuivi << ite << " FemaleParam4 " << Thetas << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
          if( accept() < exp(nextLogLik-previousLogLik) ) {
              previousLogLik = nextLogLik;
              if (suivi>0) cSuivi << "Accept" << endl;
          }
          else{
              Thetas = previousValue;
              if (suivi>0) cSuivi << "Reject" << endl;
          }
      }
      else Thetas = previousValue;


    // change Mig
    previousValue = Migs;
    Migs = previousValue*exp(0.2*gauss());
    if( Migs>mMigs && Migs<MMigs)
    {
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " FemaleParamMig " << Migs << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
        else {
        Migs = previousValue;
            if (suivi>0) cSuivi << "Reject" << endl;
        }
    }
    else Migs = previousValue;

    // change Scale
    previousValue = Scale;
    Scale = previousValue*exp(0.2*gauss());
    if( Scale>mScale && Scale<MScale)
    {
      ap=Scale*exp(gammln(2/Shape)-gammln(3/Shape));
      abp=-pow(ap,-Shape);
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " MaleParam1 " << Scale << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
      else
      {
        Scale = previousValue;
        ap=Scale*exp(gammln(2/Shape)-gammln(3/Shape));
        abp=-pow(ap,-Shape);
           if (suivi>0) cSuivi << "Reject" << endl;
      }
    }
    else Scale = previousValue;

    // change Shape
    previousValue = Shape;
    Shape = previousValue*exp(0.2*gauss());
    if( Shape>mShape && Shape<MShape)
    {
      ap=Scale*exp(gammln(2/Shape)-gammln(3/Shape));
      abp=-pow(ap,-Shape);
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " MaleParam2 " << Shape << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
      else{
        Shape = previousValue;
        ap=Scale*exp(gammln(2/Shape)-gammln(3/Shape));
        abp=-pow(ap,-Shape);
          if (suivi>0) cSuivi << "Reject" << endl;
      }
    }   
    else Shape = previousValue;

      //change Kappa
      previousValue = Kappa;
      Kappa = previousValue*exp(0.2*gauss());
      if( Kappa>mKappa && Kappa<MKappa)
      {
          nextLogLik = logLik();
          if (suivi>0) cSuivi << ite << " MaleParam3 " << Kappa << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
          if( accept() < exp(nextLogLik-previousLogLik) ) {
              previousLogLik = nextLogLik;
              if (suivi>0) cSuivi << "Accept" << endl;
          }
          else{
              Kappa = previousValue;
              if (suivi>0) cSuivi << "Reject" << endl;
          }
      }
      else Kappa = previousValue;
      
      //change Theta
      previousValue = Theta;
      Theta = fmod((previousValue + 0.2*gauss()),3.14159);
      if( Theta>mTheta && Theta<MTheta)
      {
          nextLogLik = logLik();
          if (suivi>0) cSuivi << ite << " MaleParam4 " << Theta << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
          if( accept() < exp(nextLogLik-previousLogLik) ) {
              previousLogLik = nextLogLik;
              if (suivi>0) cSuivi << "Accept" << endl;
          }
          else{
              Theta = previousValue;
              if (suivi>0) cSuivi << "Reject" << endl;
          }
      }
      else Theta = previousValue;

    // change Mig
    previousValue = Mig;
    Mig = previousValue*exp(0.2*gauss());
    if( Mig>mMig && Mig<MMig)
    {
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " MaleParamMig " << Mig << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
        else {
            Mig = previousValue;
            if (suivi>0) cSuivi << "Reject" << endl;
        }
    }
    else Mig = previousValue;

    // change Self
    previousValue = Self;
    Self = previousValue*exp(0.2*gauss());
    if( Self>mSelf && Self<MSelf)
    {
      nextLogLik = logLik();
        if (suivi>0) cSuivi << ite << " SelfingRate " << Self << " "  << previousLogLik << " " << nextLogLik << " " << nextLogLik-previousLogLik << " ";
        if( accept() < exp(nextLogLik-previousLogLik) ) {
            previousLogLik = nextLogLik;
            if (suivi>0) cSuivi << "Accept" << endl;
        }
        else {
            Self = previousValue;
            if (suivi>0) cSuivi << "Reject" << endl;
        }
    }
    else Self = previousValue;

    *ParamDisp << ite<<" " << previousLogLik
      << " " << Scales
      << " " << Shapes
      << " " << Kappas
      << " " << Thetas
      << " " << Migs
      << " " << Scale
      << " " << Shape
      << " " << Kappa
      << " " << Theta
      << " " << Mig
      << " " << Self
      <<endl;
    ParamDisp->flush();

  }
}


/***************************** PROTECTED ********************************/

long double MEMM_seedlings::logLik(int posterior)
{
    
    long double liktemp = 0;
    long double pip = 0;
    long double pip2 = 0;
    long double piptot=0;
    int pbm = 0;
    
    vector < vector<long double> > matp (NPar, vector <long double> (NPar, 0.) );
    vector < vector<long double> > mats (Ns, vector <long double> (NPar, 0.) );
    vector <long double> totp (NPar);
    vector <long double> tots (Ns);
    
    //cerr << posterior << "." ;
    for (int m=0; m<NPar; m++)
    {
        totp[m]=0;
        for (int p=0; p<m; p++)
        {
            matp[m][p]=exp(abp*pow(DistMP[m][p],Shape))*Vec_Fecp[p]*exp(Kappa*cos(AzimMP[m][p]-Theta));
            if (isnan(matp[m][p])){matp[m][p]=0; pbm=1;}
            totp[m]+=matp[m][p];
        }
        for (int p=m+1; p<NPar; p++)
        {
            matp[m][p]=exp(abp*pow(DistMP[m][p],Shape))*Vec_Fecp[p]*exp(Kappa*cos(AzimMP[m][p]-Theta));
            if (isnan(matp[m][p])){matp[m][p]=0; pbm=1;}
            totp[m]+=matp[m][p];
        }
        matp[m][m]=Self*totp[m]/(1-Mig-Self);
    }
    
    for (int s=0; s<Ns; s++)
    {
        tots[s]=0;
        for (int m=0; m<NPar; m++)
        {
            mats[s][m]=exp(abs*pow(DistSM[s][m],Shapes))*Vec_Fecs[m]*exp(Kappas*cos(AzimSM[s][m]-Thetas));
            if (isnan(mats[s][m])){mats[s][m]=0; pbm=1;}
            tots[s]+=mats[s][m];
        }
        //cout << s << " " << abs << " " << Shapes << " " << tots[s] << endl;
    }
    
    if (pbm==1) { cerr << " Warning: Overflow. One component of the dispersal matrix was not defined. " << endl;}
    
    if(posterior == 1){
        Nposterior++ ;
        for (int s=0; s<Ns; s++)
        {
            if( ProbMig[s]>0 && tots[s]>0)
            {
                pip=0;pip2=0;
                for (int m=0; m<NbMeres[s]; m++)
                {
                    pip += (ProbMeres[s][m].pere_prob)*mats[s][ProbMeres[s][m].pere_pot];
                }
                for (int m=0; m<NbCouples[s]; m++)
                {
                    pip2 += (ProbCouples[s][m].couple_prob)*mats[s][ProbCouples[s][m].mere_pot]*matp[ProbCouples[s][m].mere_pot][ProbCouples[s][m].pere_pot]/totp[ProbCouples[s][m].mere_pot];
                }
                piptot = ProbMig[s]*Migs+(1-Migs)/tots[s]*(pip*Mig+(1-Mig-Self)*pip2);
                liktemp += piptot;
                
                for (int m=0; m<NbMeres[s]; m++)
                {
                    PosteriorMeres[s][m] += (1-Migs)/tots[s]*Mig*(ProbMeres[s][m].pere_prob)*mats[s][ProbMeres[s][m].pere_pot]/piptot;
                }
                for (int m=0; m<NbCouples[s]; m++)
                {
                    PosteriorCouples[s][m] += (1-Migs)/tots[s]*(1-Mig-Self)*(ProbCouples[s][m].couple_prob)*mats[s][ProbCouples[s][m].mere_pot]*matp[ProbCouples[s][m].mere_pot][ProbCouples[s][m].pere_pot]/totp[ProbCouples[s][m].mere_pot];
                }
                
            }
        }
    }
    
    if (posterior == 2) {
        Nposterior++ ;
        for (int s=0; s<Ns; s++)
        {
            PosteriorMeres[s][NPar] += Migs;
            for (int m=0; m<NPar; m++)
            {
                //cerr << s << " " << m << " " << tots[s] << " " << mats[s][m] << " " << PosteriorMeres[s][m] << " " << PosteriorMeres[s][NPar] << " ";
                PosteriorMeres[s][m] += (1-Migs)/tots[s]*mats[s][m]/2;
                PosteriorMeres[s][NPar] += (1-Migs)/tots[s]*mats[s][m]*Mig/2;
                for (int p=0; p<NPar; p++)
                {
                    PosteriorMeres[s][p] += (1-Migs)/tots[s]*mats[s][m]*(1-Mig-Self)/totp[m]*matp[m][p]/2;
                }
                //cerr << (1-Migs)/tots[s]*mats[s][m]/2 << " " << Migs + (1-Migs)/tots[s]*mats[s][m]*Mig/2 << " " << PosteriorMeres[s][1] << " " << PosteriorMeres[s][NPar] << endl;
            }
        }
    }
    
    for (int s=0; s<Ns; s++){
        if( ProbMig[s]>0 && tots[s]>0)
        {
            pip=0;pip2=0;
            for (int m=0; m<NbMeres[s]; m++)
            {
                pip += (ProbMeres[s][m].pere_prob)*mats[s][ProbMeres[s][m].pere_pot];
            }
            for (int m=0; m<NbCouples[s]; m++)
            {
                pip2 += (ProbCouples[s][m].couple_prob)*mats[s][ProbCouples[s][m].mere_pot]*matp[ProbCouples[s][m].mere_pot][ProbCouples[s][m].pere_pot]/totp[ProbCouples[s][m].mere_pot];
            }
            liktemp += log(ProbMig[s]*Migs+(1-Migs)/tots[s]*(pip*Mig+(1-Mig-Self)*pip2));
            if (posterior==3) cout << s << " " << log(ProbMig[s]*Migs+(1-Migs)/tots[s]*(pip*Mig+(1-Mig-Self)*pip2)) << endl;
        }
    }
    
    
    return liktemp;
    
}


/*************** INIT ******************/
void MEMM_seedlings::loadSeeds(Parameters * p)
{
  int Nsl;
  string name;
  char * temp;

  if(p == NULL)return;

  cout<<endl<<"# Loading seeds... as parents"<<endl;
  allSeeds.clear();

  temp = p->getValue(MEMM_OFFSPRING_FILE_NAME);
  ifstream seeds(temp);
  if(temp) delete []temp;
  temp = p->getValue(MEMM_OFFSPRING_FILE_NUMBERS_OF_LOCUS);
  Nsl = atoi(temp);
  if(temp) delete []temp;

  Ns = 0;
  if(seeds.good())
  {
    while(seeds >> name)
    {
      cout<<name<<"...";
      allSeeds.push_back(new parent(name,seeds,0,0,Nsl));
      Ns++;
    }
    cout<<endl<<Ns<<" seeds loaded."<<endl;
    seeds.close();
  }
  else
  {
  cerr<<"#ERROR ! Can not read seeds file !"<<endl<<"Continue..."<<endl;
  }
    
    //double probtemp;
    //individu nul("nul", genotype(Nl));
    //cout << " Essai transition seed " << dynamic_cast<parent*>(allSeeds[0])->getName() << " vs mother " << dynamic_cast<parent*>(allParents[121])->getName() << endl;
    //dynamic_cast<parent*>(allSeeds[0])->mendel((*allParents[121]),nul,Nl,Na,SizeAll,AllFreq);
    
}

void MEMM_seedlings::calculDistances(Parameters *p)
{
  MEMM::calculDistances(p);

  DistSM.resize(Ns,vector<double>(NPar,0.));
    AzimSM.resize(Ns,vector<double>(NPar,0.));

    ofstream exportDistSM;
    exportDistSM.open("exportDistSM.txt");

    
  cout<< "Calcul distance and azimuths seeds - mothers"<<endl;
  for(int s=0; s<Ns; s++)
      for(int m=0; m<NPar; m++) {
      DistSM[s][m]=dynamic_cast<parent*>(allSeeds[s])->dist(*allParents[m]);
      AzimSM[s][m]=dynamic_cast<parent*>(allSeeds[s])->azim(*allParents[m]);
          exportDistSM << DistSM[s][m] << "\t" << AzimSM[s][m] << endl;
          
          if (s<=2 && m<=2) {cout << s << " x " << m << " | " << DistSM[s][m] << " , " << AzimSM[s][m] << endl;}
      }
    exportDistSM.close();

}

void MEMM_seedlings::calculTransitionMatrix(Parameters *p)
{

    cerr << " essai posterior : " << posterior;
    
  NbMeres.clear();
  NbMeres.resize(Ns);
  NbCouples.clear();
  NbCouples.resize(Ns);
  ProbMig.clear();
  ProbMig.resize(Ns);
  ProbMeres.resize(Ns);
  ProbCouples.resize(Ns);

    PosteriorMeres.resize(Ns);
    PosteriorCouples.resize(Ns);

    if(posterior==2) for(int s=0; s<Ns; s++) PosteriorMeres[s].resize(NPar+1,0.);
    
    
  individu nul("nul", genotype(Nl));
  double probtemp;
  PerePot perepottemp;
  CouplePot couplepottemp;
    
  int NMistype=0;  // NEW EK -> Considering a Maximum Number of Mistypings

    int writeProbTrans=1;
    ofstream exportProbTrans;
    if (writeProbTrans>0) exportProbTrans.open("exportProbTrans.txt");
    
    double best, scnd, nmisbest, dbest, azbest, dbest2, azbest2, dbest3, azbest3;
    int idbest, idscnd, idbest2, idscnd2;
    

    cout << endl << "Computing the mendelian likelihoods..."  << endl;
  for (int s=0; s<Ns; s++)
  {
      //cout << s << "...";
      //cout.flush();
      if (writeProbTrans>0) exportProbTrans << dynamic_cast<parent*>(allSeeds[s])->getName() << "\t";
          
    NbMeres[s]=0;
      best=-100.0;
      scnd=-100.0;
      idbest=-1;
      idscnd=-1;
      nmisbest=-1.;
      dbest=-1.;
      azbest=0.;

    ProbMig[s]=dynamic_cast<parent*>(allSeeds[s])->mendel(nul,nul,Nl,Na,SizeAll,AllFreq);
    if (ProbMig[s]==0) {cout << "Seedling # " << s << " (" << dynamic_cast<parent*>(allSeeds[s])->getName() << ") carries an unknown allele " << endl;}

    for (int m=0; m<NPar; m++)
    {
        if(!useMatError)
            probtemp = dynamic_cast<parent*>(allSeeds[s])->mendel((*allParents[m]),nul,Nl,Na,SizeAll,AllFreq);
        else
        { NMistype=0;
            probtemp = dynamic_cast<parent*>(allSeeds[s])->mendel((*allParents[m]),nul,Nl,Na,SizeAll,AllFreq,MatError,NMistype);
            //if(s<=5 && m<=5) cout<< NMistype << endl;
        }

        if (probtemp>0 && NMistype <= NMistypeMax)  // NEW EK -> Considering a Maximum Number of Mistypings
      {
        NbMeres[s]++;
          if (log10(probtemp)>best) {
              scnd=best; idscnd=idbest;
              best=log10(probtemp); idbest=m;
              nmisbest=NMistype;
              dbest=dynamic_cast<parent*>(allSeeds[s])->dist((*allParents[m]));
              azbest=dynamic_cast<parent*>(allSeeds[s])->azim((*allParents[m]));
          }
          else if (log10(probtemp)>scnd) {scnd=log10(probtemp); idscnd=m; }
        perepottemp.pere_pot=m;
        perepottemp.pere_prob=probtemp;
        ProbMeres[s].push_back(perepottemp);
          if(posterior==1) PosteriorMeres[s].push_back(0); // NEW EK -> Computing posterior probabilities of parents
      }
    }
      cout << "Seedling # " << s << " has " << NbMeres[s] << " compatible parents : ";
      for (int m=0; m < NbMeres[s]; m++) cout << dynamic_cast<parent*>(allParents[ProbMeres[s][m].pere_pot])->getName() << " | ";
      cout << endl;
      
     if (writeProbTrans>0) exportProbTrans << log10(ProbMig[s]) << "\t" << NbMeres[s] << "\t" << best << "\t" << scnd << "\t" << idbest << "\t" << idscnd << "\t";
       if (writeProbTrans>0) exportProbTrans << nmisbest << "\t" << dbest << "\t" << azbest << "\t";
      
      
      best=-100.0;
      scnd=-100.0;
      idbest=-1;idbest2=-1;
      idscnd=-1;idscnd2=-1;
      nmisbest=-1.;
      dbest=-1.;dbest2=-1.;dbest3=-1.;
      azbest=0.;azbest2=0.;azbest=0.;

    for (int m=0; m<NbMeres[s]; m++)
    {
      for (int p=0; p<NbMeres[s]; p++)
      {
        
          if(!useMatError)
              probtemp = dynamic_cast<parent*>(allSeeds[s])->mendel((*allParents[ProbMeres[s][m].pere_pot]),(*allParents[ProbMeres[s][p].pere_pot]),Nl,Na,SizeAll,AllFreq);
          else
              { NMistype=0;
                  probtemp = dynamic_cast<parent*>(allSeeds[s])->mendel((*allParents[ProbMeres[s][m].pere_pot]),(*allParents[ProbMeres[s][p].pere_pot]),Nl,Na,SizeAll,AllFreq,MatError,NMistype);
              //if(s<=5 && m<=5) cout<< NMistype << endl;
              }
          
        if (probtemp>0 && NMistype <= NMistypeMax)  // NEW EK -> Considering a Maximum Number of Mistypings
        {
          NbCouples[s]++;
            if (log10(probtemp)>best && !(ProbMeres[s][m].pere_pot==idbest2 && ProbMeres[s][p].pere_pot==idbest)) {
                scnd=best; idscnd=idbest; idscnd2=idbest2;
                best=log10(probtemp); idbest=ProbMeres[s][m].pere_pot; idbest2=ProbMeres[s][p].pere_pot;
                nmisbest=NMistype;
                dbest=dynamic_cast<parent*>(allSeeds[s])->dist((*allParents[ProbMeres[s][m].pere_pot]));
                dbest2=dynamic_cast<parent*>(allSeeds[s])->dist((*allParents[ProbMeres[s][p].pere_pot]));
                dbest3=dynamic_cast<parent*>(allParents[ProbMeres[s][m].pere_pot])->dist((*allParents[ProbMeres[s][p].pere_pot]));
                azbest=dynamic_cast<parent*>(allSeeds[s])->azim((*allParents[ProbMeres[s][m].pere_pot]));
                azbest2=dynamic_cast<parent*>(allSeeds[s])->azim((*allParents[ProbMeres[s][p].pere_pot]));
                azbest3=dynamic_cast<parent*>(allParents[ProbMeres[s][m].pere_pot])->azim((*allParents[ProbMeres[s][p].pere_pot]));
            }
            else if (log10(probtemp)>scnd) {scnd=log10(probtemp); idscnd=ProbMeres[s][m].pere_pot; idscnd2=ProbMeres[s][p].pere_pot;}
          couplepottemp.mere_pot=ProbMeres[s][m].pere_pot;
          couplepottemp.pere_pot=ProbMeres[s][p].pere_pot;
          couplepottemp.couple_prob=probtemp;
          ProbCouples[s].push_back(couplepottemp);
          if(posterior==1) PosteriorCouples[s].push_back(0); // NEW EK -> Computing posterior probabilities of parents

        }
      }
    }
      
      if (writeProbTrans>0) exportProbTrans << NbCouples[s] << "\t" << best << "\t" << scnd << "\t" << idbest << "\t" << idbest2 << "\t" << idscnd << "\t" << idscnd2 << "\t";
      if (writeProbTrans>0) exportProbTrans << nmisbest << "\t" << dbest << "\t" << dbest2 << "\t" << dbest3 << "\t" << azbest << "\t" << azbest2 << "\t" << azbest3 << "\t" << endl;

      cout << "Seedling # " << s << " has " << NbCouples[s] << " compatible couples : ";
      for (int m=0; m < NbCouples[s]; m++) cout << dynamic_cast<parent*>(allParents[ProbCouples[s][m].mere_pot])->getName() << " x " << dynamic_cast<parent*>(allParents[ProbCouples[s][m].pere_pot])->getName() << " | ";
      cout << endl << "--------------------" << endl;

  }
    if (writeProbTrans>0) exportProbTrans << endl;
    //cout << PosteriorMeres[1][1] << " " << PosteriorMeres[5][NPar] << endl;
  cout << endl << "Computation of the mendelian likelihoods : OK. " <<endl << endl;

}

void MEMM_seedlings::loadPrior(Parameters *p)
{
  char *temp, *temp2, *temp3;

  MEMM::loadPrior(p);

  cout<< "Load more prior..."<<endl;
  temp = p->getValue(MEMM_GAMAS_INIT);
  GamAs = atof(temp);
  temp2 = p->getValue(MEMM_GAMAS_MIN);
  mGamAs = atof(temp2);
  temp3 = p->getValue(MEMM_GAMAS_MAX);
  MGamAs = atof(temp3);
  cout << "GamAs : "<< GamAs << " [" <<mGamAs <<"|"<< MGamAs << "]"<<endl;
  if(temp) delete []temp;
  if(temp2) delete []temp2;
  if(temp3) delete []temp3;

   // piOs
   temp = p->getValue(MEMM_IND_FEC_DIST);
    if( strcmp("zigamma",temp) == 0 ) {
            if(temp) delete []temp;
            temp = p->getValue(MEMM_PI0S_INIT);
            Pi0s = atof(temp);
            temp2 = p->getValue(MEMM_PI0S_MIN);
            mPi0s = atof(temp2);
            temp3 = p->getValue(MEMM_PI0S_MAX);
            MPi0s = atof(temp3);
            cout << "pi0s : "<< Pi0s << " [" <<mPi0s <<"|"<< MPi0s << "]"<<endl;
            if(temp) delete []temp;
            if(temp2) delete []temp2;
            if(temp3) delete []temp3;
    }else { if(temp) delete []temp; }
    
  temp = p->getValue(MEMM_SCALES_INIT);
  Scales = atof(temp);
  temp2 = p->getValue(MEMM_SCALES_MIN);
  mScales = atof(temp2);
  temp3 = p->getValue(MEMM_SCALES_MAX);
  MScales = atof(temp3);
  cout << "Scales : "<< Scales << " [" <<mScales <<"|"<< MScales << "]"<<endl;
  if(temp) delete []temp;
  if(temp2) delete []temp2;
  if(temp3) delete []temp3;

  temp = p->getValue(MEMM_SHAPE_S_INIT);
  Shapes = atof(temp);
  temp2 = p->getValue(MEMM_SHAPE_S_MIN);
  mShapes = atof(temp2);
  temp3 = p->getValue(MEMM_SHAPE_S_MAX);
  MShapes = atof(temp3);
  cout << "Shapes : "<< Shapes << " [" <<mShapes <<"|"<< MShapes << "]"<<endl;
  if(temp) delete []temp;
  if(temp2) delete []temp2;
  if(temp3) delete []temp3;

    
    // NEW anisotropie

    temp = p->getValue(MEMM_THETAS_INIT);
    Thetas = atof(temp);
    temp2 = p->getValue(MEMM_THETAS_MIN);
    mThetas = atof(temp2);
    temp3 = p->getValue(MEMM_THETAS_MAX);
    MThetas = atof(temp3);
    cout << "Thetas : "<< Thetas << " [" <<mThetas <<"|"<< MThetas << "]"<<endl;
    if(temp) delete []temp;
    if(temp2) delete []temp2;
    if(temp3) delete []temp3;

    temp = p->getValue(MEMM_KAPPAS_INIT);
    Kappas = atof(temp);
    temp2 = p->getValue(MEMM_KAPPAS_MIN);
    mKappas = atof(temp2);
    temp3 = p->getValue(MEMM_KAPPAS_MAX);
    MKappas = atof(temp3);
    cout << "Kappas : "<< Kappas << " [" <<mKappas <<"|"<< MKappas << "]"<<endl;
    if(temp) delete []temp;
    if(temp2) delete []temp2;
    if(temp3) delete []temp3;

    
    
    
  temp = p->getValue(MEMM_MIG_RATE_S_INIT);
  Migs = atof(temp);
  temp2 = p->getValue(MEMM_MIG_RATE_S_MIN);
  mMigs = atof(temp2);
  temp3 = p->getValue(MEMM_MIG_RATE_S_MAX);
  MMigs = atof(temp3);
  cout << "Migs : "<< Migs << " [" <<mMigs <<"|"<< MMigs << "]"<<endl;
  if(temp) delete []temp;
  if(temp2) delete []temp2;
  if(temp3) delete []temp3;

  as=Scales*exp(gammln(2/Shapes)-gammln(3/Shapes));
  cout <<"Deltas : "<<as<<endl;
  abs=-pow(as,-Shapes);
  ap=Scale*exp(gammln(2/Shape)-gammln(3/Shape));
  cout <<"Deltap : "<<ap<<endl;
  abp=-pow(ap,-Shape);

  Vec_Fecs.resize(NPar, 1.0 );
  Vec_Fecp.resize(NPar, 1.0 );

  cout<<"end loading prior"<<endl;

}

void MEMM_seedlings::loadParameters(Parameters *p)
{
  char * temp;
  MEMM::loadParameters(p);

//  temp = p->getValue(MEMM_IND_FEC_DIST);
//  if( strcmp("LN",temp) == 0 ) pLois = new MEMM_logNormal(gauss);
//  else pLois = new MEMM_gamma(GamAs,accept);
//  delete []temp;
    
    temp = p->getValue(MEMM_IND_FEC_DIST);
    if( strcmp("LN",temp) == 0 ) pLois = new MEMM_logNormal(gauss);
    else if( strcmp("gamma",temp) == 0 || strcmp("gama",temp) == 0) pLois = new MEMM_gamma(GamAs,accept);
    else pLois = new MEMM_zigamma(Pi0s, GamAs, accept);
    if(temp) delete []temp;

    
}

// NEW EK -> Computing posterior probabilities of parents

void MEMM_seedlings::exportPosteriors(Parameters * p)
{
    double tottemp;
    double probtemp;   // EK -> Inclus Mistyping
    string name;
    char * temp;
    int NMistype;    // EK -> Inclus Mistyping
    individu nul("nul", genotype(Nl));
    
    if(p == NULL)return;
    
    cout<<endl<<"# Exporting the posterior probabilities ... "<<endl;
    cout<<endl<<"Based on ... "<< Nposterior << "  sampled MCMC steps" << endl;
    
    temp = p->getValue(MEMM_POSTERIOR_FILE_NAME);
    ofstream fposterior(temp,std::ofstream::out);

    if (posterior==2)
    {   fposterior << "Seed#  SeedID  ";
        for (int m=0; m<NPar; m++) fposterior << dynamic_cast<parent*>(allParents[m])->getName() << " ";
        fposterior << "OUT" << endl;
    }
    
    for (int s=0; s<Ns && fposterior.good(); s++)
    {
        
        if (posterior==1) {
        
        tottemp=1;
        //fposterior << "-----------------------------------" << endl;
        for (int m=0; m<NbMeres[s]; m++) {
            NMistype=0;   // EK -> Inclus Mistyping
            probtemp = dynamic_cast<parent*>(allSeeds[s])->mendel((*allParents[ProbMeres[s][m].pere_pot]),nul,Nl,Na,SizeAll,AllFreq,MatError,NMistype); // EK -> Inclus Mistyping
            fposterior << s << " " << dynamic_cast<parent*>(allSeeds[s])->getName() << " " << dynamic_cast<parent*>(allParents[ProbMeres[s][m].pere_pot])->getName() << " OUT ";
            fposterior << ProbMeres[s][m].pere_prob << " " << NMistype << " " << PosteriorMeres[s][m]/Nposterior << endl;  // EK -> Inclus Mistyping
            tottemp -= PosteriorMeres[s][m]/Nposterior;
        }
            
        for (int m=0; m<NbCouples[s]; m++) {
            NMistype=0;  // EK -> Inclus Mistyping
            probtemp = dynamic_cast<parent*>(allSeeds[s])->mendel((*allParents[ProbCouples[s][m].mere_pot]),(*allParents[ProbCouples[s][m].pere_pot]),Nl,Na,SizeAll,AllFreq,MatError,NMistype);  // EK -> Inclus Mistyping
            fposterior << s << " " << dynamic_cast<parent*>(allSeeds[s])->getName() << " " << dynamic_cast<parent*>(allParents[ProbCouples[s][m].mere_pot])->getName() << " ";
            fposterior << dynamic_cast<parent*>(allParents[ProbCouples[s][m].pere_pot])->getName() << " " << ProbCouples[s][m].couple_prob << " " << NMistype << " "  <<  PosteriorCouples[s][m]/Nposterior << endl;  // EK -> Inclus Mistyping
            tottemp -= PosteriorCouples[s][m]/Nposterior;
        }
        fposterior << s << " " << dynamic_cast<parent*>(allSeeds[s])->getName() << " OUT OUT " << ProbMig[s] << " 0 " << tottemp << endl; // EK -> Inclus Mistyping
            
        }
        
        else if (posterior==2)
            
        {
            fposterior << s << " " << dynamic_cast<parent*>(allSeeds[s])->getName() << " ";
            for (int m=0; m<NPar+1; m++) fposterior << PosteriorMeres[s][m]/Nposterior << " ";
            fposterior << endl;
            
        }
    }
    
    fposterior.close();
    if(temp) delete []temp;
}


