#include "locus.h"
#include <iostream>
#include <map>
#include <vector>
#include <string>

locus::locus(int all1, int all2) {
    _allele[0]=all1;
    _allele[1]=all2;  }

locus::~locus() {}

void locus::afficher() const {
    std::cout << "{" << _allele[0] << " , " << _allele[1] << "}, ";
}

double locus::mendel1 (const locus & mere , const locus & pere, int na,  std::map<int,int> sizeall, const std::vector<double> & freqall) const {
    std::vector<double> tempm (na);
    std::vector<double> tempp (na);
    double temp;

//    std::cout << "{ " << this->_allele[0] << " , " << this->_allele[1] << " }  vs. { ";
//   std::cout << mere._allele[0] << " , " << mere._allele[1] << " } x { ";
//    std::cout << pere._allele[0] << " , " << pere._allele[1] << " } = ";

    for (int i=0; i<2; i++) {
        if (mere._allele[i]<0) {
            for (int j=0;j<na; j++) {tempm[j]+=freqall[j]/2;}}
        else {tempm[sizeall[mere._allele[i]]]+=0.5;}
        if (pere._allele[i]<0) {
            for (int j=0;j<na; j++) {tempp[j]+=freqall[j]/2;}}
        else {tempp[sizeall[pere._allele[i]]]+=0.5;}}

    if (this->_allele[0] < 0) {
        if (this->_allele[1] < 0) {temp=1;}
        else {temp=tempp[sizeall[this->_allele[1]]]/2+tempm[sizeall[this->_allele[1]]]/2;}}
    else {
        if (this->_allele[1] < 0) {temp=tempp[sizeall[this->_allele[0]]]/2+tempm[sizeall[this->_allele[0]]]/2;}
        else {
            if (this->_allele[0]==this->_allele[1]) {temp=tempm[sizeall[this->_allele[0]]]*tempp[sizeall[this->_allele[0]]];}
            else {temp=tempm[sizeall[this->_allele[0]]]*tempp[sizeall[this->_allele[1]]]+tempm[sizeall[this->_allele[1]]]*tempp[sizeall[this->_allele[0]]];}}}

//    std::cout << temp << std::endl;
    return(temp);

}


// NEW EK: mendel avec prise en compte des erreurs
double locus::mendelError(const locus & mere , const locus & pere, int na,  std::map<int,int> sizeall, const std::vector<double> & freqall, const std::vector< std::vector <double> > & materror) const {
    std::vector<double> tempm (na);
    std::vector<double> tempp (na);
    std::vector<double> tempm2 (na);    // NEW EK
    std::vector<double> tempp2 (na);    // NEW EK
    double temp;
    
    //    std::cout << "{ " << this->_allele[0] << " , " << this->_allele[1] << " }  vs. { ";
    //   std::cout << mere._allele[0] << " , " << mere._allele[1] << " } x { ";
    //    std::cout << pere._allele[0] << " , " << pere._allele[1] << " } = ";
    
    for (int i=0; i<2; i++) {
        if (mere._allele[i]<0) {
            for (int j=0;j<na; j++) {tempm[j]+=freqall[j]/2;}}
        else {tempm[sizeall[mere._allele[i]]]+=0.5;}
        if (pere._allele[i]<0) {
            for (int j=0;j<na; j++) {tempp[j]+=freqall[j]/2;}}
        else {tempp[sizeall[pere._allele[i]]]+=0.5;}}
    
    // NEW EK
    for(int j=0; j<na; j++) {
        tempm2[j]=0;
        tempp2[j]=0;
        for(int k=0; k<na; k++) {
            tempm2[j]+= materror[j][k]*tempm[k];
            tempp2[j]+= materror[j][k]*tempp[k];
        }
    }
        tempm=tempm2;
        tempp=tempp2;
    //
        
    if (this->_allele[0] < 0) {
        if (this->_allele[1] < 0) {temp=1;}
        else {temp=tempp[sizeall[this->_allele[1]]]/2+tempm[sizeall[this->_allele[1]]]/2;}}
    else {
        if (this->_allele[1] < 0) {temp=tempp[sizeall[this->_allele[0]]]/2+tempm[sizeall[this->_allele[0]]]/2;}
        else {
            if (this->_allele[0]==this->_allele[1]) {temp=tempm[sizeall[this->_allele[0]]]*tempp[sizeall[this->_allele[0]]];}
            else {temp=tempm[sizeall[this->_allele[0]]]*tempp[sizeall[this->_allele[1]]]+tempm[sizeall[this->_allele[1]]]*tempp[sizeall[this->_allele[0]]];}}}
    
    //    std::cout << temp << std::endl;
    return(temp);
    
}

